﻿using System;
using BepInEx;
using UnboundLib;
using UnboundLib.Cards;
using ShipOfFoolsRounds.Cards;
using HarmonyLib;
using CardChoiceSpawnUniqueCardPatch.CustomCategories;
using System.Collections.Generic;
using RarityLib.Utils;
using UnityEngine;
//using Nullmanager;


namespace ShipOfFoolsRounds
{
    // These are the mods required for our mod to work
    [BepInDependency("com.willis.rounds.unbound", BepInDependency.DependencyFlags.HardDependency)]
    [BepInDependency("pykess.rounds.plugins.moddingutils", BepInDependency.DependencyFlags.HardDependency)]
    [BepInDependency("pykess.rounds.plugins.cardchoicespawnuniquecardpatch", BepInDependency.DependencyFlags.HardDependency)]
    [BepInDependency("root.rarity.lib", BepInDependency.DependencyFlags.HardDependency)]
    [BepInDependency("com.Root.Null", BepInDependency.DependencyFlags.HardDependency)]
    // Declares our mod to Bepin
    [BepInPlugin("com.larree.rounds.ShipOfFools", "ShipOfFoolsRounds", "0.0.1")]
    // The game our mod is associated with
    [BepInProcess("Rounds.exe")]
    public class ShipOfFoolsRounds : BaseUnityPlugin
    {
        private const string ModId = "com.larree.rounds.ShipOfFools";
        private const string ModName = "ShipOfFoolsRounds";
        public const string Version = "0.0.1"; // What version are we on (major.minor.patch)?
        public const string ModInitials = "SoF";
        //internal static IEnumerable<CardCategory> noLotteryCategories;

        public static ShipOfFoolsRounds instance { get; private set; }
        void Awake()
        {
            // Use this to call any harmony patch files your mod may have
            var harmony = new Harmony("com.larree.rounds.ShipOfFools");
            harmony.PatchAll();
            
            RarityUtils.AddRarity("GoldTrinket", 0.05f, new Color32(255, 128, 0, byte.MaxValue), new Color32(255, 128, 0, byte.MaxValue));
        }
        void Start()
        {
            instance = this;
            
            CustomCard.BuildCard<Plank>();
            CustomCard.BuildCard<TriplePlank>();
            CustomCard.BuildCard<Shellbie>();
            CustomCard.BuildCard<GoldBullet>();
            CustomCard.BuildCard<Corkscrew>();
            CustomCard.BuildCard<Corn>();
            CustomCard.BuildCard<LightDrill>();
            CustomCard.BuildCard<Todd>();
            CustomCard.BuildCard<DoubleShot>();
        }
    }
}
